<?php
define("FILTER_EQUAL", 1);
define("FILTER_CONTAIN", 2);
define("FILTER_MATCH", 3);

function __Alias($key){
	return Stats::CallBack($key);
}
function __Alias2($key){
	return Stats::CallBack2($key);
}
function __Alias3($key){
	return Stats::CallBack3($key);
}
class Stats{
	private $nvault;
	private $filename = STATSFILE;
	
	private $readtime;
	private $updatetime;
	
	public static $filter;
	public static $filterMode = FILTER_CONTAIN;
		
	public function Stats(){
		$this->nvault = new nVaultRead();
		if(!$this->nvault->Open($this->filename)){
			die("<h1>Bd przetwarzania pliku .vault</h1>");
		}
	}
        public function ClassToNum($class){
            for($i=1;$i<count(Classes::$names);$i++){
                if(Classes::$names[$i] == $class)
                    return $i;
            }
            return -1;
        }
	public function Load($sort = true){
		$time = microtime(true);

		$this->nvault->fullLoadEntries();
		if($sort)
			$this->nvault->sort();

		$time2 = microtime(true);
		$this->readtime = $time2-$time;

		$this->updatetime = filemtime($this->filename);
	}
	public function setFilter($filter){
		Stats::$filter = $filter;
		if(strlen($filter)){
			switch(Stats::$filterMode){
				case FILTER_EQUAL:{
					$this->nvault->setKeyFilter('__Alias');
					break;
				}
				case FILTER_CONTAIN:{
					$this->nvault->setKeyFilter('__Alias2');
					break;
				}
				case FILTER_MATCH:{
					$this->nvault->setKeyFilter('__Alias3');
					break;
				}
			}
			
		}else{
			$this->nvault->setKeyFilter(NULL);
		}
	}
	public static function CallBack($key){
		return strcmp($key, Stats::$filter) == 0;
	}
	public static function CallBack2($key){
		return strstr($key, Stats::$filter) != "";
	}
	public static function CallBack3($key){
		return preg_match(Stats::$filter, $key);
	}
	public function print_r(){
		$this->nvault->print_r();
	}
	public function listing($start, $limit, $page=0, $max=0){
		$startBuff = $start;
		Theme::HTML_PreListing();
		$limit = min($limit, count($this->nvault->Entries));
		$counter = 0;

                
		foreach($this->nvault->Entries as $key => $data){
			if($start > 0){
				$start --;
				continue;
			}
			$value = $data->Value;
			
			$key = str_replace("-cod","",$key);

			$ile = 0;
			for($i=strlen($key)-1;$i>=0;$i--){
				if($key[$i] == '-'){
                                        if($ile){
                                            $key = array(substr($key, 0, $i), substr($key, $i+1, $ile-$i-1));
                                            break;
                                        }else{
                                            $ile = $i;
                                        }
				}
			}
			$value = explode("#", $value);

			$value = array_slice($value, 1);

                       
                        $key[1] = $this->ClassToNum($key[1]);
			if($key[0]){
				Theme::HTML_Item($startBuff+$counter+1, $key, $value);
				if(++$counter >= $limit) break;
			}
		}
		Theme::HTML_PostListing();
		Theme::HTML_Paginator($page, $max);
	}
	
	public function getReadTime(){
		return $this->readtime;
	}
	public function getUpdateTime($format = "d-m-Y H:m"){
		return date($format, $this->updatetime);
	}
	public function getLoadedNum(){
		return count($this->nvault->Entries);
	}
};

?>